<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<meta http-equiv="Content-type" content="text/html;charset=UTF-8">
	<link rel="stylesheet" href="./css/skies.css" media="screen" type="text/css" title="Eternal Blue">
	<link rel="stylesheet" href="./css/print.css" media="print" type="text/css">
	<link rel="alternate stylesheet" href="./css/print.css" media="screen" type="text/css" title="Print Preview">
	<title>Search Results</title>
</head>
<body>

<div id="top" align="center">
	<div id="header">
		Search Results
	</div>
</div>

<div id="nav_box">
	<ul id="nav">
		<li><a href="./index.html">Candidate Index</a></li>
		<li><a href="./search.html">Search Page</a></li>
		<li><a href="../akelara/index.html">Clan Akelara</a></li>
		<li><a href="../koshi/index.html">Koshi Keidai</a></li>
		<li><a href="../anuzzeru/index.html">Anuzzeru alAtars</a></li>
	</ul>
</div>

<div id="container">
	<div class="content">
		<?php

/*This time, I've chosen to put the php code in the center of the document,
surrounded by the html. No real reason for this, other than I felt like doing it.
As you can also see, I've chosen to create custom functions for my own use. This
is for a bit of cleanliness, because this way I can keep loops down to approximately
one screen-length. You'll notice that array_building is pretty long. That couldn't
really be helped, because of all the small things that I needed to check.

This function: array_building accepts a $key from the $_POST ($key will
be the name of the input, such as Name, Color, etc), and the array of values
associated with that key. */

		function array_building($key, $keyarray){
//			echo "Inside function array_building with $key<br><br>";
			$counts = count($keyarray); //counting how many values are in the array
			$custom = 0;
			if($key == "Artist"){
				$result = artist_switch($keyarray); //if Artist was selected, jump to the artist_switch function
				return $result;
			}
			if($key == "Color" || $key == "MarkingColor"){
//				echo "Inside if $key == Color or MarkingColor <br><br>";
				$custom = 1; //a flag for use later, only activated if the key is Color or MarkingColor
			}
			if($counts == 1 && $custom != 1){
				$result = "$key='" . $keyarray[0] . "'"; //result form example: Gender='Male'
				return $result;
			}
			else{
				$result = ""; //intializing the result value
				if($custom == 1){
					$result .= "("; // $result = "("  -- if the array is a color array
				}
				$result .= "$key IN ("; //$result = "(Color IN (" OR "Gender IN ("
				for($i = 0; $i < $counts; $i++){
					$result .= "'" . $keyarray[$i] . "'"; //iterating through all the values and tacking them on
					if($i < ($counts-1)){
						$result .= ","; //if we aren't dealing with the last value, add a , between values'
					}
					if($key == "Color"){
//						echo "Inside $key == Color. Color is $keyarray[$i]<br>";
						$ccolors[] = $keyarray[$i]; //if the key is Color, add the color we just selected to a new array
					}
					if($key == "MarkingColor"){
//						echo "Inside $key == MarkingColor. MarkingColor is $keyarray[$i]<br>";
						$cmarkings[] = $keyarray[$i]; //or if the key is MarkingColor, do the same with a different array
					}
				} //here, $result = "(Color IN ('Red','Green'" OR "Gender IN ('Male','Female')"
				if($custom == 1){
					if($key == "Color"){
						$result .= ") OR (Color='Gradient' AND Notes REGEXP '"; //$result = "(Color IN ('Red','Green') OR (Color='Gradient' AND Notes REGEXP '"
//						echo "Inside custom == 1.<br>";
//						print_r($ccolors);
//						echo "<br>";
						$result = build_colors($result, $ccolors); //tossing the colors array to build_colors
					}
					else{
						$result .= ") OR (MarkingColor='Gradient' AND Notes REGEXP '"; //result is the same as above, just replace Color with MarkingColor
						$result = build_colors($result, $cmarkings); //tossing the marking colors array to build_colors
					}
					//after the if/else: $result = "(Color IN ('Red','Green') OR (Color='Gradient' AND Notes REGEXP 'Red|Green'"
					$result .= ")"; //closing off one set of parens
				}
				$result .= ")"; //closing off the last set of parens
				return $result; //tossing the result back to the caller
			}
		}

/*This function accepts two values, $result is assumed to be a string, $colors is assumed to be an array.
It then counts how many values are in the color array, then iterates through and builds a string in
the form Red|Green that's added to the string $result. A final ' is added, then the result is passed back.
*/

		function build_colors($result, $colors){
//			echo "Inside function build_colors.<br>";
			$counting = count($colors);
//			echo "Counting is $counting<br>";
			for($k = 0; $k < $counting; $k++){
//				echo "Color is $colors[$k] <br>";
				$result .= $colors[$k];
				if($k < ($counting-1)){
					$result .= "|";
				}
			}
			$result .= "'";
			return $result;
		}

/*this function accepts a list of artist names, counts how many there are, then calls a for loop
that calls the function switching on every one. If the last name hasn't been reached, another ,
is added and the loop repeats.' It returns a string in the form of "Origin IN ('Healing Den','Planet Twenty')"*/

		function artist_switch($artists){
			$count = count($artists);
			$result = "Origin IN (";
			for($i = 0; $i < $count; $i++){
				$result .= switching($artists[$i]);
				if($i < ($count-1)){
					$result .= ",";
				}
			}
			$result .= ")";
			return $result;

		}

/*This function exists merely as a switch statement. It takes an artist name, runs down its
case structure until it finds a match, then returns the string it's told to'*/

		function switching($artist){
			switch($artist){
				case "Dray":
					return "'Nidus Corona','Dray','Star City','The Bower'";
					break;
				case "Jkat":
					return "'Avengaea'";
					break;
				case "DNS":
					return "'DNS'";
					break;
				case "Unknown":
					return "'Unknown'";
					break;
				case "Sherra":
					return "'Cy Dragonstake'";
					break;
				case "Cy":
					return "'Castello Hollic'";
					break;
				case "Shard":
					return "'Healing Den','Planet Twenty'";
					break;
				case "StarFyre":
					return "'Clan Akelara','Koshi Keidai'";
					break;
				case "Trix":
					return "'Lantessama'";
					break;
				case "Phoenix":
					return "'Phoenix','Abstract Destiny'";
					break;
				case "Myrror":
					return "'Everrealm'";
					break;
				case "Kitsuneko":
					return "'Drockh-Tallahn Castle','Darkling Dawn'";
					break;
				case "Starburst":
					return "'Starburst'";
					break;
				case "DF":
					return "'DF','Kynn'";
					break;
				case "Astra":
					return "'Moonstruck','Astra'";
					break;
				case "Veritosos":
					return "'Veritosos'";
					break;
				case "Sil":
					return "'Sil'";
					break;
				case "Shadow":
					return "'Shadow','Moon Forest'";
					break;
				case "Kless":
					return "'Kless'";
					break;
				case "Swift":
					return "'Swift'";
					break;
				case "Yakima":
					return "'Anarendor','Falas'";
					break;
				case "Mystic":
					return "'Mystic'";
					break;
				case "Naeodin":
					return "'Naeodin'";
					break;
				case "Ty":
					return "'Ty'";
					break;
			}
		}

		//connecting to DB

		$dbname = "silver13_dragonbase";
		$pathname = "http://www.silveredmagic.com/candis/";

		mysql_connect("localhost", "silver13_DrakDex", "WEPsucks") or
			die("Could not connect: " . mysql_error());
		mysql_select_db($dbname);

/*Now into the 'main' function, so to speak. The if($_POST) checks if anything has been
passed to it. If POST is empty, the if will not execute and the line "Please go back and enter a search query"
will be displayed.*/

		if($_POST){

			$vars = $_POST;
			$j = 0;
			foreach($vars as $key => $value){ //foreach is a very useful loop structure that can iterated through arrays
//				echo "$key and $value<br><br>"; //$key is the name of the form input, $value is the values attached to it
				if($value){ //technically, every form input gives a result, though the $value may be empty, this checks if $value exists
//					echo "Inside $key <br>";
					if(is_array($vars[$key])){ //if the $value set attached to $key is an array, enter here
						$store[] = array_building($key, $vars[$key]); //and promptly pass it off to someone else
					}//if end
					else{
						$temp = trim($value); //if it isn't an array, then it probably needs some whitespace trimmed to make sure no errors are generated
						if($key == "Name"){
							$store[] = "$key REGEXP '$temp'"; //because Names are stored as text values and not enums, I need to use REGEXP command here
						}
						else{
	//						echo $temp;
	//						echo "<br>";
							$store[] = "$key='$temp'"; //if it isn't a name, just use Column_Name='Value' form
						}
					}//else end
				}//if $value end
			}//foreach end

//			print_r($store);

			$sql = "SELECT * FROM Dragons WHERE ";
			$varcount = count($store);

/*And here we build the SELECT statement. As it iterates, if we haven't reached the last statement, add an AND in*/

			for($i = 0; $i < $varcount; $i++){
				$sql .= $store[$i];
				if($i < ($varcount-1)){
					$sql .= " AND ";
				}
			}

//			echo $sql;
//			echo "<br><br>";

/*Grabbing results, checking them, then turning them into a proper array to iterate through.*/

			$result = mysql_query($sql);

			if (!$result) {
				echo "DB Error, could not list tables\n";
				echo 'MySQL Error: ' . mysql_error();
				exit;
			}

			while ($row = mysql_fetch_array($result)) {
				$results[] = $row;
			}

			$rcount = count($results);
//			echo "There are $rcount results in the results array.<br><br>";

			$output = "<div align=\"center\">
						<div class=\"table\">
						<table class=\"stats\">
							<tr>
								<th colspan=\"8\" align=\"center\">$rcount Results.</th>
							</tr>
							<tr>
								<td>Image</td>
								<td>Name</td>
								<td>Species</td>
								<td>Gender</td>
								<td>Size</td>
								<td>Color</td>
								<td>Markings</td>
								<td>Origin</td>
							</tr>
							";

/*Now we're into the easy stuff. The output string has been initialized above,
and now we enter a for loop that cycles through every result gained from the query
and puts it into a tidy table format. If the species is listed as Myrsilk or Drak
the algorithm queries the Notes section and tacks that onto the front (giving results
like "Ice Myrsilk" or "Ore Drak"). If the color is listed as a Gradient, it queries Notes
and tacks that on after (EX: Gradient Blue-Green)e If the marking color is listed as gradient,
same deal (EX: Gradient Blue-Green Points).'*/

			for($j = 0; $j < $rcount; $j++){
				$image = $pathname . $results[$j]['Thumbnail'];
				$link = $pathname . $results[$j]['Link'];
				$name = $results[$j]['Name'];
				$species = $results[$j]['Species'];
				$gender = $results[$j]['Gender'];
				$size = $results[$j]['Size'];
				$color = $results[$j]['Color'];
				$mcolor = $results[$j]['MarkingColor'];
				$markings = $results[$j]['MarkingColor'] . " " . $results[$j]['Markings'];
				$origin = $results[$j]['Origin'];

				if($species == "Myrsilk" || $species == "Drak"){
					$species = $results[$j]['Notes'] . " " . $results[$j]['Species'];
				}
				if($color == "Gradient"){
					$color = $results[$j]['Color'] . " " . $results[$j]['Notes'];
				}
				if($mcolor == "Gradient"){
					$markings = $results[$j]['MarkingColor'] . " " . $results[$j]['Notes'] . " " . $results[$j]['Markings'];
				}

				$output .= "<tr>
							<td><img src=\"$image\" alt=\"$name\"></td>
							<td><a href=\"$link\">$name</a>
							<td>$species</td>
							<td>$gender</td>
							<td>$size</td>
							<td>$color</td>
							<td>$markings</td>
							<td>$origin</td>
						</tr>
							";
			}

		$output .= "</table></div></div>";
		echo $output;

		}
		else{
			echo "Please go back and enter a search query.";
		}

		?>
	</div>
</div>
<div id="footer" class="centered">
	Page and information &copy;StarFyre unless otherwise noted.
</div>
</body>
</html>

